## mingw-w64-qucs-s-25.1.0-1.src.tar.zst

=== CMakeLists.txt ===
SET(CMAKE_BUILD_TYPE Release)
cmake_minimum_required(VERSION 3.10)
PROJECT(qucs-suite CXX)

set(QUCS_NAME "qucs-s")

# Prohibit in-source builds
if("${CMAKE_BINARY_DIR}" STREQUAL "${CMAKE_SOURCE_DIR}")
  message(
    FATAL_ERROR
      "QUCS-S: You cannot build in a source directory (or any directory with "
      "CMakeLists.txt file). Please make a build subdirectory. Feel free to "
      "remove CMakeCache.txt and CMakeFiles.")
endif()

set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

file (STRINGS "${qucs-suite_SOURCE_DIR}/VERSION" QUCS_VERSION)

if(DEFINED CI_VERSION)
    set(PROJECT_VERSION "${CI_VERSION}")
else()
    set(PROJECT_VERSION "${QUCS_VERSION}")
endif()

message(STATUS "Configuring Qucs: VERSION ${PROJECT_VERSION}")

set(GIT "")
if(EXISTS ${CMAKE_SOURCE_DIR}/.git )
  find_package(Git)
  # Get the latest abbreviated commit hash of the working branch
  execute_process(
    COMMAND ${GIT_EXECUTABLE} log --pretty=format:%h -n 1
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
    OUTPUT_VARIABLE GIT_COMMIT_HASH
  )
  set(GIT ${GIT_COMMIT_HASH})
  message(STATUS "Found Git repository, last commit hash: ${GIT}")
endif()

message(STATUS "${PROJECT_NAME} ${CMAKE_INSTALL_PREFIX} ${qucs-suite_BINARY_DIR}" )

find_package(Qt6 REQUIRED COMPONENTS Core Gui Widgets LinguistTools)
set(QT_VERSION ${Qt6Core_VERSION})

message(STATUS "Qt Version: " ${QT_VERSION})

add_definitions(${QT_DEFINITIONS})
set(CMAKE_POSITION_INDEPENDENT_CODE ON)

if(NOT CMAKE_BUILD_TYPE STREQUAL "Debug")
    add_compile_definitions(QT_NO_DEBUG_OUTPUT)
endif()

add_subdirectory( qucs )
#add_subdirectory( converter )
add_subdirectory( qucs-activefilter )
add_subdirectory( qucs-attenuator )
#add_subdirectory( qucs-doc )
add_subdirectory( qucs-filter )
add_subdirectory( library )
add_subdirectory( qucs-transcalc )
add_subdirectory( qucs-powercombining )
add_subdirectory( qucs-s-spar-viewer )
#add_subdirectory( examples )
if(EXISTS ${CMAKE_SOURCE_DIR}/qucsator_rf/CMakeLists.txt)
    add_subdirectory(qucsator_rf)
else()
    message("Qucsator RF submodule not found. Please update submodules")
endif()

IF (UPDATE_TRANSLATIONS)
  file(GLOB_RECURSE FILES_TO_TRANSLATE "*.cpp" "*.h" "*.ui")
ENDIF (UPDATE_TRANSLATIONS)
add_subdirectory( translations )

install(DIRECTORY "examples" DESTINATION "share/${QUCS_NAME}")

install(FILES contrib/io.github.ra3xdh.qucs_s.metainfo.xml DESTINATION ${CMAKE_INSTALL_PREFIX}/share/metainfo)

#
# Custom uninstall target
#
configure_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/cmake/uninstall.cmake.in"
    "${CMAKE_CURRENT_BINARY_DIR}/uninstall.cmake"
    IMMEDIATE @ONLY)

add_custom_target(uninstall
    COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/uninstall.cmake)

=== qucs-s-spar-viewer/CMakeLists.txt ===
PROJECT(qucs-s-spar-viewer CXX C)
CMAKE_MINIMUM_REQUIRED(VERSION 3.10)
cmake_policy(VERSION 3.10)

SET(QUCS_NAME "qucs-s")

# use top VERSION file
file (STRINGS ${PROJECT_SOURCE_DIR}/../VERSION QUCS_VERSION)

if(DEFINED CI_VERSION)
    set(PROJECT_VERSION "${CI_VERSION}")
else()
    set(PROJECT_VERSION "${QUCS_VERSION}")
endif()

message(STATUS "Configuring ${PROJECT_NAME} (GUI): VERSION ${PROJECT_VERSION}")

set(PROJECT_VENDOR "Qucs-S team. This program is licensed under the GNU GPL")
set(PROJECT_COPYRIGHT_YEAR "2024")
set(PROJECT_DOMAIN_FIRST "qucs")
set(PROJECT_DOMAIN_SECOND "org")


add_compile_definitions(HAVE_CONFIG_H)
SET(CMAKE_POSITION_INDEPENDENT_CODE ON)

# configure the header config.h
CONFIGURE_FILE (
    "${PROJECT_SOURCE_DIR}/../config.h.cmake"
    "${PROJECT_BINARY_DIR}/config.h"
)

INCLUDE_DIRECTORIES("${PROJECT_BINARY_DIR}")

find_package(Qt6 REQUIRED COMPONENTS Core Gui Widgets Charts)
include_directories(
      ${Qt6Core_INCLUDE_DIRS}
      ${Qt6Gui_INCLUDE_DIRS}
      ${Qt6Widgets_INCLUDE_DIRS}
      )


if (${QT_VERSION} VERSION_LESS "6.7.0")
    set(CMAKE_CXX_STANDARD 17)
else()
    set(CMAKE_CXX_STANDARD 20)
endif()
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

if (CMAKE_BUILD_TYPE STREQUAL "Debug")
    if (CMAKE_CXX_COMPILER_ID STREQUAL "MSVC")
        add_compile_definitions(_CRT_SECURE_NO_WARNINGS _SCL_SECURE_NO_WARNINGS)
        add_compile_options(/permissive- /Zc:__cplusplus /Zc:preprocessor /MP /Od /vmg)
        add_compile_options(/wd4244 /wd4267 /wd4312)
    else()
        add_compile_options(-Wall -Wextra -O0 -g)
        if (CMAKE_CXX_COMPILER_ID MATCHES "^AppleClang$|^Clang$")
            add_compile_options(-Wno-ignored-attributes)
        endif()
    endif()
elseif(CMAKE_BUILD_TYPE STREQUAL "Release")
    if (CMAKE_CXX_COMPILER_ID STREQUAL "MSVC")
        add_compile_definitions(_CRT_SECURE_NO_WARNINGS _SCL_SECURE_NO_WARNINGS)
        string(REGEX REPLACE "/W1" "/w" CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")
        add_compile_options(/permissive- /Zc:__cplusplus /Zc:preprocessor /MP /vmg)
        add_link_options(/OPT:REF /OPT:ICF)
    else()
        add_compile_options(-w)
    endif()
endif()

ADD_DEFINITIONS(${QT_DEFINITIONS})

#ADD_SUBDIRECTORY( bitmaps ) -> added as resources

SET( spar_viewer_sources main.cpp qucs-s-spar-viewer.cpp codeeditor.cpp)

SET( spar_viewer_moc_headers qucs-s-spar-viewer.h codeeditor.h)

SET(RESOURCES qucs-s-spar-viewer.qrc)

QT6_WRAP_CPP( spar_viewer_moc_sources ${spar_viewer_moc_headers} )
QT6_ADD_RESOURCES(RESOURCES_SRCS ${RESOURCES})

IF(APPLE)
  # set information on Info.plist file
	SET(MACOSX_BUNDLE_INFO_STRING "${PROJECT_NAME} ${PROJECT_VERSION}")
  SET(MACOSX_BUNDLE_BUNDLE_VERSION "${PROJECT_NAME} ${PROJECT_VERSION}")
  SET(MACOSX_BUNDLE_LONG_VERSION_STRING "${PROJECT_NAME} ${PROJECT_VERSION}")
  SET(MACOSX_BUNDLE_SHORT_VERSION_STRING "${PROJECT_VERSION}")
  SET(MACOSX_BUNDLE_COPYRIGHT "${PROJECT_COPYRIGHT_YEAR} ${PROJECT_VENDOR}")
  SET(MACOSX_BUNDLE_GUI_IDENTIFIER "${PROJECT_DOMAIN_SECOND}.${PROJECT_DOMAIN_FIRST}")
  SET(MACOSX_BUNDLE_BUNDLE_NAME "${PROJECT_NAME}")
  SET(MACOSX_BUNDLE_ICON_FILE qucs-s-spar-viewer.icns)

  # set where in the bundle to put the icns file
  SET_SOURCE_FILES_PROPERTIES(${CMAKE_CURRENT_SOURCE_DIR}/../qucs/bitmaps/qucs-s-spar-viewer.icns PROPERTIES MACOSX_PACKAGE_LOCATION Resources)
  # include the icns file in the target
  SET(spar_viewer_sources ${spar_viewer_sources} ${CMAKE_CURRENT_SOURCE_DIR}/../qucs/bitmaps/qucs-s-spar-viewer.icns)

ENDIF(APPLE)

ADD_EXECUTABLE( ${QUCS_NAME}spar-viewer MACOSX_BUNDLE WIN32
  ${spar_viewer_sources}
  ${spar_viewer_moc_sources}
  ${RESOURCES_SRCS}
  codeeditor.cpp
  codeeditor.h )

TARGET_LINK_LIBRARIES( ${QUCS_NAME}spar-viewer Qt6::Core Qt6::Gui Qt6::Widgets Qt6::Charts )
SET_TARGET_PROPERTIES(${QUCS_NAME}spar-viewer PROPERTIES POSITION_INDEPENDENT_CODE TRUE)
#INSTALL (TARGETS ${QUCS_NAME}spar-viewer DESTINATION bin)
#
# Prepare the installation
#
SET(plugin_dest_dir bin)
SET(qtconf_dest_dir bin)
SET(APPS "${CMAKE_INSTALL_PREFIX}/bin/${QUCS_NAME}spar-viewer")
IF(APPLE)
  SET(plugin_dest_dir ${QUCS_NAME}spar-viewer.app/Contents/MacOS)
  SET(qtconf_dest_dir ${QUCS_NAME}spar-viewer.app/Contents/Resources)
  SET(APPS "${CMAKE_INSTALL_PREFIX}/bin/${QUCS_NAME}spar-viewer.app")
ENDIF(APPLE)

IF(WIN32)
  SET(APPS "${CMAKE_INSTALL_PREFIX}/bin/${QUCS_NAME}spar-viewer.exe")
ENDIF(WIN32)

#
# Install the Qucs application, on Apple, the bundle is
# installed as on other platforms it'll go into the bin directory.
#
INSTALL(TARGETS ${QUCS_NAME}spar-viewer
    BUNDLE DESTINATION bin COMPONENT Runtime
    RUNTIME DESTINATION bin COMPONENT Runtime
    )


#
# Install needed Qt plugins by copying directories from the qt installation
# One can cull what gets copied by using 'REGEX "..." EXCLUDE'
#
IF(APPLE AND QT_PLUGINS_DIR)
  INSTALL(DIRECTORY "${QT_PLUGINS_DIR}/imageformats" DESTINATION bin/${plugin_dest_dir}/plugins COMPONENT Runtime)
ENDIF()
#
# install a qt.conf file
# this inserts some cmake code into the install script to write the file
#
IF(APPLE)
INSTALL(CODE "
    file(WRITE \"\${CMAKE_INSTALL_PREFIX}/bin/${qtconf_dest_dir}/qt.conf\" \"\")
    " COMPONENT Runtime)
ENDIF()

#--------------------------------------------------------------------------------
# Use BundleUtilities to get all other dependencies for the application to work.
# It takes a bundle or executable along with possible plugins and inspects it
# for dependencies.  If they are not system dependencies, they are copied.

# directories to look for dependencies
IF(APPLE)
  SET(DIRS ${QT_LIBRARY_DIRS})
ENDIF()

# Now the work of copying dependencies into the bundle/package
# The quotes are escaped and variables to use at install time have their $ escaped
# An alternative is the do a configure_file() on a script and use install(SCRIPT  ...).
# Note that the image plugins depend on QtSvg and QtXml, and it got those copied
# over.
IF(APPLE)
INSTALL(CODE "
    file(GLOB_RECURSE QTPLUGINS
      \"\${CMAKE_INSTALL_PREFIX}/bin/${plugin_dest_dir}/plugins/*${CMAKE_SHARED_LIBRARY_SUFFIX}\")
    include(BundleUtilities)
    fixup_bundle(\"${APPS}\" \"\${QTPLUGINS}\" \"${DIRS}\")
    " COMPONENT Runtime)
ENDIF()

=== qucs-transcalc/bitmaps/CMakeLists.txt ===

SET(XPMS )

SET(PNGS
c_microstrip.png
coax.png
microstrip.png
stripline.png
rectwaveguide.png
cpw.png
cpw_back.png)

SET(ICON )

INSTALL( FILES ${PNGS} DESTINATION share/qucs/bitmaps )

=== qucs/extsimkernels/CMakeLists.txt ===
# qucs/extsimkernels library
# Classes and GUI for external simulation kernels (ngspice, xyce, etc.) interfacing

INCLUDE_DIRECTORIES( ${CMAKE_CURRENT_SOURCE_DIR}
                     ${CMAKE_CURRENT_BINARY_DIR} )

#INCLUDES = $(X11_INCLUDES) $(QT_INCLUDES) -I$(top_srcdir)/qucs

SET(EXTSIMKERNELS_HDRS
externsimdialog.h
abstractspicekernel.h
ngspice.h
xyce.h
qucs2spice.h
spicecompat.h
customsimdialog.h
simsettingsdialog.h
verilogawriter.h
s2spice.h
spicelibcompdialog.h
#xspice_cmbuilder.h
#codemodelgen.h
)

SET(EXTSIMKERNELS_SRCS
externsimdialog.cpp
abstractspicekernel.cpp
ngspice.cpp
xyce.cpp
qucs2spice.cpp
spicecompat.cpp
customsimdialog.cpp
simsettingsdialog.cpp
verilogawriter.cpp
CdlNetlistWriter.cpp
s2spice.cpp
spicelibcompdialog.cpp
#xspice_cmbuilder.cpp
#codemodelgen.cpp
)

SET(EXTSIMKERNELS_MOC_HDRS
externsimdialog.h
abstractspicekernel.h
ngspice.h
xyce.h
customsimdialog.h
simsettingsdialog.h
spicelibcompdialog.h
)

QT6_WRAP_CPP( EXTSIMKERNELS_MOC_SRCS ${EXTSIMKERNELS_MOC_HDRS} )


ADD_LIBRARY(extsimkernels STATIC ${EXTSIMKERNELS_HDRS} ${EXTSIMKERNELS_SRCS} ${EXTSIMKERNELS_MOC_SRCS})

ADD_SUBDIRECTORY( xspice )

=== qucs/spicecomponents/CMakeLists.txt ===
# qucs/components library

INCLUDE_DIRECTORIES( ${CMAKE_CURRENT_SOURCE_DIR} )

#INCLUDES = $(X11_INCLUDES) $(QT_INCLUDES) -I$(top_srcdir)/qucs

SET(COMPONENTS_SRCS
src_eqndef.cpp

#SPICE sections

sp_parameter.cpp
sp_csparameter.cpp
sp_globalpar.cpp
sp_options.cpp
sp_nutmeg.cpp
sp_ic.cpp
sp_nodeset.cpp
sp_model.cpp
sp_include.cpp
sp_lib.cpp
sp_func.cpp
sp_spiceinit.cpp
incl_script.cpp

#end of SPICE section

vsffm.cpp
isffm.cpp
vAmpMod.cpp
iAmpMod.cpp
vPWL.cpp
iPWL.cpp
eNL.cpp
gNL.cpp
vTRNOISE.cpp
iTRNOISE.cpp
vTRRANDOM.cpp
C_SPICE.cpp
L_SPICE.cpp
R_SPICE.cpp
K_SPICE.cpp
MESFET_SPICE.cpp
PMF_MESFET_SPICE.cpp
LTL_SPICE.cpp
UDRCTL_SPICE.cpp
LTRA_SPICE.cpp
DIODE_SPICE.cpp
NPN_SPICE.cpp
PNP_SPICE.cpp
BJT_SPICE.cpp
NJF_SPICE.cpp
PJF_SPICE.cpp
NMOS_SPICE.cpp
PMOS_SPICE.cpp
MOS_SPICE.cpp

# SPICE simulations list

sp_customsim.cpp
sp_fourier.cpp
sp_disto.cpp
sp_noise.cpp
sp_pz.cpp
xyce_script.cpp
sp_sens.cpp
sp_sens_ac.cpp
sp_sens_xyce.cpp
sp_sens_tr_xyce.cpp
sp_spectrum.cpp

# 
# Qucs-S new components cpp list
#


S4Q_V.cpp
S4Q_Ieqndef.cpp
S4Q_I.cpp
S4Q_S.cpp
S4Q_W.cpp
#
# XSPICE cpp list
#

Icouple.cpp
core.cpp
SDTF.cpp
XAPWL.cpp

#XSPICE CodeModel
xspicegeneric.cpp
#xsp_cmlib.cpp
#xsp_codemodel.cpp

#SPICE file devices
spicegeneric.cpp
spicelibcomp.cpp
)

SET(COMPONENTS_HDRS
spicecomponents.h
src_eqndef.h

#SPICE sections

sp_parameter.h
sp_csparameter.h
sp_globalpar.h
sp_options.h
sp_nutmeg.h
sp_ic.h
sp_nodeset.h
sp_model.h
sp_include.h
sp_lib.h
sp_func.h
sp_spiceinit.h
incl_script.h

#end SPICE sections

vsffm.h
isffm.h
vAmpMod.h
iAmpMod.h
vPWL.h
iPWL.h
eNL.h
gNL.h
vTRNOISE.h
iTRNOISE.h
vTRRANDOM.h
C_SPICE.h
L_SPICE.h
R_SPICE.h
K_SPICE.h
MESFET_SPICE.h
PMF_MESFET_SPICE.h
LTL_SPICE.h
UDRCTL_SPICE.h
LTRA_SPICE.h
DIODE_SPICE.h
NPN_SPICE.h
PNP_SPICE.h
BJT_SPICE.h
NJF_SPICE.h
PJF_SPICE.h
NMOS_SPICE.h
PMOS_SPICE.h
MOS_SPICE.h
sp_customsim.h
sp_fourier.h
sp_disto.h
sp_noise.h
sp_pz.h
sp_sens.h
sp_sens_ac.h
sp_sens_xyce.h
sp_sens_tr_xyce.h
xyce_script.h
sp_spectrum.h

# 
# Qucs-S new components h list
#

S4Q_V.h
S4Q_Ieqndef.h
S4Q_I.h
S4Q_S.h
S4Q_W.h
#
# XSPICE component headers
#

Icouple.h
core.h
SDTF.h
XAPWL.h

#XSPICE codemodel

xspicegeneric.h
#xsp_cmlib.h
#xsp_codemodel.h

#SPICE file devices
spicegeneric.h
spicelibcomp.h
)


ADD_LIBRARY(spicecomponents STATIC ${COMPONENTS_HDRS} ${COMPONENTS_SRCS} ${COMPONENTS_MOC_SRCS} )

=== qucsator_rf/src/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)
project(qucsator_rf CXX C)

#
# Checks for libraries.
#
# AC_CHECK_LIB(m, sin) need to check for sin?
if(NOT WIN32)
  find_library(MATH_LIB NAMES m)
  if(NOT MATH_LIB)
    message(SEND_ERROR "Math lib not found: ${MATH_LIB}")
  else()
    message(STATUS "Math lib found at: ${MATH_LIB}")
  endif()
endif()

#
# Check for type sizes.
#
include(CheckTypeSize)

#
# Check for double type. * valid types are: double, float and long double. *
# defines: nr_double_t,  The global type of double representation. * defines:
# NR_DOUBLE_SIZE,  The size of the double representation. * Use -DENABLE-
# DOUBLE="[float,double, long double]"
if(ENABLE-DOUBLE)
  # User defined
  set(DoubleType ${ENABLE-DOUBLE})

  # valid types
  set(ValidTypes "float" "double" "long double")

  list(FIND ValidTypes ${DoubleType} HasType)
  if(HasType EQUAL -1)
    message(FATAL_ERROR "Valid types are: ${ValidTypes}")
  endif()

  # The global type of double representation.
  set(nr_double_t DoubleType)
  check_type_size(${DoubleType} DoubleSize)

  # The size of the double representation.
  set(NR_DOUBLE_SIZE ${DoubleSize})
else()
  # Default double
  set(DoubleType "double")
  # The global type of double representation.
  set(nr_double_t ${DoubleType})
  check_type_size(${DoubleType} DoubleSize)

  # The size of the double representation.
  set(NR_DOUBLE_SIZE ${DoubleSize})
endif()
message(STATUS "using double type: ${DoubleType}; size: ${DoubleSize}")

# defines used in qucs_typedefs.h
set(QUCS_INT32_TYPE ${nr_int32_t})
set(QUCS_INT16_TYPE ${nr_int16_t})
set(QUCS_DOUBLE_TYPE ${DoubleType})
set(QUCS_DOUBLE_SIZE ${DoubleSize})
#
# Configure the header qucs_typedefs.h, interpolate above definitions.
#
configure_file("${qucs-core_SOURCE_DIR}/qucs_typedefs.h.cmake"
               "${qucs-core_BINARY_DIR}/qucs_typedefs.h")


#
# Configure the header config.h, interpolate above definitions.
#
configure_file("${qucs-core_SOURCE_DIR}/config.h.cmake"
               "${qucs-core_BINARY_DIR}/config.h")

#
# List of lexer/parsers type names
#
set(ParserTypes
    csv
    citi
    dataset
    mdl
    netlist
    touchstone
    zvr)

set(generated_SRC)
foreach(type ${ParserTypes})
  # Create custom Bison
  set(bisonIn "${CMAKE_CURRENT_SOURCE_DIR}/parse_${type}.ypp")
  set(bisonOut "parse_${type}.hpp"
               "parse_${type}.cpp")
  add_custom_command(
    OUTPUT ${bisonOut}
    COMMAND
      ${BISON_EXECUTABLE}
      --defines=parse_${type}.hpp
      --output=parse_${type}.cpp
      ${bisonIn}
    DEPENDS ${bisonIn})
  # Create custom Flex
  set(flexIn "${CMAKE_CURRENT_SOURCE_DIR}/scan_${type}.lpp")
  set(flexOut "scan_${type}.cpp")
  add_custom_command(
    OUTPUT ${flexOut}
    COMMAND ${FLEX_EXECUTABLE} --outfile=${flexOut} ${flexIn}
    DEPENDS ${flexIn})

  list(APPEND generated_SRC ${bisonOut})
  list(APPEND generated_SRC ${flexOut})
endforeach()


#
# Source code libqucs
#
set(LIBQUCS_SRC
    ${generated_SRC}
    analysis.cpp
    check_zvr.cpp
    interpolator.cpp
    parasweep.cpp
    property.cpp
    range.cpp
    spline.cpp
    strlist.cpp
    trsolver.cpp
    acsolver.cpp
    check_citi.cpp
    check_csv.cpp
    check_dataset.cpp
    check_mdl.cpp
    check_netlist.cpp
    check_touchstone.cpp
    circuit.cpp
    dataset.cpp
    dcsolver.cpp
    devstates.cpp
    differentiate.cpp
    environment.cpp
    equation.cpp # <= depends on gperfapphash.cpp
    evaluate.cpp
    exception.cpp
    exceptionstack.cpp
    fourier.cpp
    hbsolver.cpp
    history.cpp
    input.cpp
    integrator.cpp
    logging.c
    matvec.cpp
    module.cpp
    net.cpp
    nodelist.cpp
    nodeset.cpp
    object.cpp
    receiver.cpp
    spsolver.cpp
    sweep.cpp
    transient.cpp
    variable.cpp
    vector.cpp)

#
# Template classes
#
set(TEMPLATES
    tmatrix.h
    tvector.h
    eqnsys.h
    nasolver.h
    states.h
    tvector.h
    ptrlist.h
    tridiag.h
    hash.h
    valuelist.h
    nasolution.h)

#
# Include headers to be installed
#
set(PUBLIC_HEADERS
    ${qucs-core_BINARY_DIR}/config.h
    ${qucs-core_BINARY_DIR}/qucs_typedefs.h
    circuit.h
    compat.h
    constants.h
    consts.h
    integrator.h
    logging.h
    net.h
    netdefs.h
    node.h
    object.h
    states.h
    valuelist.h
    vector.h
    property.h
    ptrlist.h
    characteristic.h
    pair.h
    operatingpoint.h)

include_directories(
  ${qucs-core_SOURCE_DIR}/src/math # precision.h
  ${qucs-core_SOURCE_DIR}/src/ # compat.h
  ${qucs-core_SOURCE_DIR}/src/components # microstrip/substrate.h
  ${qucs-core_SOURCE_DIR}/src/interface
  ${qucs-core_BINARY_DIR} # cmake generated config.h
  ${qucs-core_BINARY_DIR}/src # cmake generated gperfapphash.h
  ${qucs-core_BINARY_DIR}/src/components # generated verilog/[].core.h
)

add_executable(repl_reg repl_reg.cpp)
IF(WIN32)
    SET(repl_reg_exe repl_reg.exe)
ELSE() # Unix
    SET(repl_reg_exe repl_reg)
ENDIF()
#
# Replace 'evaluate::[whatever]' by NULL
#
# * evaluate.h (class evaluate): New class implementing the actual evaluation
#   function (applications) for the equations in Qucs.
#
add_custom_command(
  OUTPUT gperfappgen.h
  COMMAND ${repl_reg_exe} ${CMAKE_CURRENT_SOURCE_DIR}/applications.h  ${CMAKE_CURRENT_BINARY_DIR}/gperfappgen.h 0
  DEPENDS ${repl_reg_exe} ${applications.h} )

#
# Compile gperfappgen * used to generate gperf input file (used in qucsator)
#
set(gperf_SRC gperfappgen.cpp gperfappgen.h)

add_executable(gperfappgen ${gperf_SRC})

#
# Run gperfappgen, pipe to gperf input to gperfapphash.gph
#
IF(WIN32)
    SET(gperfappgen_exe gperfappgen.exe)
ELSE() # Unix
    SET(gperfappgen_exe gperfappgen)
ENDIF()

add_custom_command(
  OUTPUT gperfapphash.gph
  COMMAND ${gperfappgen_exe} > ${CMAKE_CURRENT_BINARY_DIR}/gperfapphash.gph && dos2unix ${CMAKE_CURRENT_BINARY_DIR}/gperfapphash.gph  
  DEPENDS ${gperfappgen_exe})

#
# Run gperf, create hash table. * -I, Include the necessary system include files
# at the beginning of the code. * -m, Perform multiple iterations to minimize
# generated table. * Replace '{""}' by '{"",0}; (why?)
#
add_custom_command(
  OUTPUT gperfapphash.cpp
  COMMAND ${GPERF_TOOL} -I -m 8 ${CMAKE_CURRENT_BINARY_DIR}/gperfapphash.gph >
          temp.gperf
  COMMAND ${repl_reg_exe} temp.gperf ${CMAKE_CURRENT_BINARY_DIR}/gperfapphash.cpp 1
  DEPENDS gperfapphash.gph ${repl_reg_exe})

# target <- source (includea) equation.cpp: gperfapphash.cpp
#
# noinst_PROGRAMS = gperfappgen gperfappgen_SOURCES = gperfappgen.cpp

# for cleaning (autogenerated) set(gperf_FILES gperfapphash.cpp gperfapphash.gph
# gperfappgen.h)

# Qucs library dependencies
add_subdirectory(interface)
add_subdirectory(components)
add_subdirectory(components/digital)
add_subdirectory(components/devices)
add_subdirectory(components/microstrip)
if (WITH_ADMS)
add_subdirectory(components/verilog)
endif()
add_subdirectory(math)

# Qucsconv application
add_subdirectory(converter)

# Linux? set(CMAKE_SHARED_LINKER_FLAGS "-Wl,--export-all-symbols")

#
# Create qucsator
#
add_executable(qucsator_rf ucs.cpp ${PUBLIC_HEADERS} ${TEMPLATES})

#
# Build libqucs as SHARED, dynamic library
#
# After: - http://stackoverflow.com/questions/11429055/cmake-how-create-a-
# single-shared-library-from-all-static-libraries-of-subprojec
#
if (WITH_ADMS)
add_library(
    libqucsator STATIC
  ${LIBQUCS_SRC}
  ${TEMPLATES}
  $<TARGET_OBJECTS:coreMath>
  $<TARGET_OBJECTS:coreComponents>
  $<TARGET_OBJECTS:coreInterface>
  $<TARGET_OBJECTS:coreVerilog>
  $<TARGET_OBJECTS:coreMicrostrip>
  $<TARGET_OBJECTS:coreDevices>
  $<TARGET_OBJECTS:coreDigital>)
else()
add_library(
    libqucsator STATIC
  ${LIBQUCS_SRC}
  ${TEMPLATES}
  $<TARGET_OBJECTS:coreMath>
  $<TARGET_OBJECTS:coreComponents>
  $<TARGET_OBJECTS:coreInterface>
# $<TARGET_OBJECTS:coreVerilog>
  $<TARGET_OBJECTS:coreMicrostrip>
  $<TARGET_OBJECTS:coreDevices>
  $<TARGET_OBJECTS:coreDigital>)
endif()

# rename the library to let it be libqucsator (not liblibqucsator)
set_target_properties(libqucsator PROPERTIES OUTPUT_NAME qucsator)

#
# Create target to handle gperfapp dependency
#
add_custom_target(equation DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/gperfapphash.cpp
                                   equation.cpp)
add_dependencies(libqucsator equation)

#
# Link qucsator and libqucsator
#
target_link_libraries(qucsator_rf libqucsator ${CMAKE_DL_LIBS})

#
# Handle install
#
install(TARGETS qucsator_rf DESTINATION bin)

# set Windows runtime location for libqucsator See:
# http://www.cmake.org/pipermail/cmake/2010-June/037461.html
#install(
#  TARGETS libqucsator
#  RUNTIME DESTINATION bin COMPONENT runtime
#  ARCHIVE DESTINATION lib COMPONENT devel
#  LIBRARY DESTINATION lib COMPONENT library)

if(WITH_ADMS)
install(FILES ${PUBLIC_HEADERS} DESTINATION include/qucs-core)
endif()

=== qucsator_rf/src/components/CMakeLists.txt ===
include_directories(${qucs-core_CURRENT_SOURCE_DIR}
                    ${qucs-core_SOURCE_DIR}/src/math)

set(COMPONENTS_SRC
    amplifier.cpp
    attenuator.cpp
    biastee.cpp
    capacitor.cpp
    capq.cpp
    cccs.cpp
    ccvs.cpp
    circline.cpp
    circulator.cpp
    coaxline.cpp
    coupler.cpp
    cross.cpp
    ctline.cpp
    dcblock.cpp
    dcfeed.cpp
    ecvs.cpp
    taperedline.cpp
    ground.cpp
    gyrator.cpp
    hybrid.cpp
    iac.cpp
    idc.cpp
    iexp.cpp
    ifile.cpp
    iinoise.cpp
    inductor.cpp
    indq.cpp
    inoise.cpp
    iprobe.cpp
    ipulse.cpp
    irect.cpp
    isolator.cpp
    itrafo.cpp
    ivnoise.cpp
    mutual.cpp
    mutual2.cpp
    mutualx.cpp
    opamp.cpp
    open.cpp
    pac.cpp
    phaseshifter.cpp
    rectline.cpp
    relais.cpp
    resistor.cpp
    rfedd.cpp
    rlcg.cpp
    short.cpp
    spfile.cpp
    spembed.cpp
    spdeembed.cpp
    strafo.cpp
    tee.cpp
    tline.cpp
    tline4p.cpp
    trafo.cpp
    tswitch.cpp
    twistedpair.cpp
    vac.cpp
    vam.cpp
    vccs.cpp
    vcvs.cpp
    vdc.cpp
    vexp.cpp
    vfile.cpp
    vnoise.cpp
    vpm.cpp
    vprobe.cpp
    vpulse.cpp
    vrect.cpp
    vvnoise.cpp
    wprobe.cpp)

set(HEADERS component.h component_id.h components.h)

add_library(coreComponents OBJECT ${COMPONENTS_SRC})

if(WITH_ADMS)
install(FILES ${HEADERS} DESTINATION include/qucs-core)
endif()

=== qucsator_rf/src/components/devices/CMakeLists.txt ===
include_directories(
  ${qucs-core_CURRENT_SOURCE_DIR}
  ${qucs-core_SOURCE_DIR}/src/math ${qucs-core_SOURCE_DIR}/src/components
)# component.h

set(DEVICES_SRC
    bjt.cpp
    device.cpp
    diac.cpp
    diode.cpp
    eqndefined.cpp
    jfet.cpp
    mosfet.cpp
    thyristor.cpp
    triac.cpp
    tunneldiode.cpp)

add_library(coreDevices OBJECT ${DEVICES_SRC})

set(HEADERS device.h)

if (WITH_ADMS)
install(FILES ${HEADERS} DESTINATION include/qucs-core)
endif()

=== qucsator_rf/src/components/verilog/CMakeLists.txt ===
include_directories(
  ${qucs-core_CURRENT_SOURCE_DIR}
  ${qucs-core_SOURCE_DIR}/src/math
  ${qucs-core_SOURCE_DIR}/src/components # component.h
  ${qucs-core_SOURCE_DIR}/src/components/devices) # devices.h

set(VA_FILES
    andor4x2.va
    andor4x3.va
    andor4x4.va
    binarytogrey4bit.va
    comp_1bit.va
    comp_2bit.va
    comp_4bit.va
    dff_SR.va
    DLS_1ton.va
    DLS_nto1.va
    dmux2to4.va
    dmux3to8.va
    dmux4to16.va
    EKV26MOS.va
    fa1b.va
    fa2b.va
    gatedDlatch.va
    greytobinary4bit.va
    ha1b.va
    hpribin4bit.va
    jkff_SR.va
    log_amp.va
    logic_0.va
    logic_1.va
    MESFET.va
    mod_amp.va
    mux2to1.va
    mux4to1.va
    mux8to1.va
    nigbt.va
    pad2bit.va
    pad3bit.va
    pad4bit.va
    photodiode.va
    phototransistor.va
    potentiometer.va
    tff_SR.va
    vcresistor.va)

# XML scripts need to build, the order matters
set(XML_BUILD
   analogfunction.xml
   qucsVersion.xml
   qucsMODULEcore.xml
   qucsMODULEdefs.xml)

# Concatenate scripts into command: -e script1 [-e script2]
set(XML_CMD)
foreach(script ${XML_BUILD})
  set(XML_CMD ${XML_CMD} -e ${CMAKE_CURRENT_SOURCE_DIR}/${script})
endforeach()

# Process each Verilog-A file.
set(gen_SRC)
foreach(file ${VA_FILES})
  get_filename_component(_name ${file} NAME_WE)
  set(output
      ${_name}.${_name}.analogfunction.h
      ${_name}.${_name}.analogfunction.cpp
      ${_name}.${_name}.core.cpp
      ${_name}.core.h
      ${_name}.cpp
      ${_name}.defs.h)
  # custom command/rule to generate outputs with admsXml
  add_custom_command(
    OUTPUT ${output}
    COMMAND ${ADMSXML} ${CMAKE_CURRENT_SOURCE_DIR}/${file} ${XML_CMD} -o
            ${_name}
    DEPENDS ${file} ${XML_BUILD})
  list(APPEND gen_SRC ${_name}.cpp)
endforeach()

add_library(coreVerilog OBJECT ${gen_SRC})

# Distribute XML scripts
set(XML_DIST ${XML_BUILD} qucsMODULEgui.xml qucsMODULEguiJSONsymbol.xml)

set(MAKE_FILES cpp2lib.makefile va2cpp.makefile)

install(FILES ${XML_DIST} DESTINATION include/qucs-core)
install(FILES ${MAKE_FILES} DESTINATION include/qucs-core)

=== PKGBUILD ===
# Maintainer: Kreijstal <kreijstal@hotmail.com>

_realname=qucs-s
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}")
pkgver=25.1.0
pkgrel=1
pkgdesc="A spin-off of Qucs that supports other free SPICE circuit simulators like ngspice with the same Qucs GUI"
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url='https://ra3xdh.github.io/'
msys2_repository_url='https://github.com/ra3xdh/qucs_s'
license=('spdx:gpl-2.0')
groups=("${MINGW_PACKAGE_PREFIX}-eda")
depends=(
  "${MINGW_PACKAGE_PREFIX}-qt6-base"
  "${MINGW_PACKAGE_PREFIX}-gcc-libs"
  "${MINGW_PACKAGE_PREFIX}-ngspice"
  "${MINGW_PACKAGE_PREFIX}-qt6-svg"
  "${MINGW_PACKAGE_PREFIX}-qt6-charts"

)
makedepends=(
  "${MINGW_PACKAGE_PREFIX}-cc"
  "${MINGW_PACKAGE_PREFIX}-cmake"
  "${MINGW_PACKAGE_PREFIX}-ninja"
  "${MINGW_PACKAGE_PREFIX}-qt6-tools"
  "${MINGW_PACKAGE_PREFIX}-python"
  "${MINGW_PACKAGE_PREFIX}-gperf"
)
source=(
  "https://github.com/ra3xdh/qucs_s/releases/download/${pkgver}/${_realname}-${pkgver}.tar.gz"
)
sha256sums=('66fcbaf56cec741ed7f5d60491a1ffafcc1fb5d96485df8319012d2c66a11fee')

build() {
  cd "${srcdir}/${_realname}-${pkgver}"
  mkdir -p build-${MSYSTEM} && cd build-${MSYSTEM}

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
    cmake \
    -GNinja \
    -DCMAKE_INSTALL_PREFIX="${MINGW_PREFIX}" \
    -DCMAKE_BUILD_TYPE="Release" \
    -DCI_VERSION="${pkgver}" \
    ..

  cmake --build .
}


package() {
  cd "${srcdir}/${_realname}-${pkgver}/build-${MSYSTEM}"
  DESTDIR="${pkgdir}" cmake --install .
}

=== debian/control ===
Source: qucs-s
Section: electronics
Priority: optional
Maintainer: Vadim Kuznetsov <ra3xdh@gmail.com>
Build-Depends: debhelper-compat (= 13), cmake, flex, bison,
 qtbase5-dev, qttools5-dev, libqt5svg5-dev, gperf, dos2unix
Rules-Requires-Root: no
Standards-Version: 4.6.2
Homepage: https://ra3xdh.github.io
Vcs-Browser: https://github.com/ra3xdh/qucs_s/
Vcs-Git: https://github.com/ra3xdh/qucs_s.git

Package: qucs-s
Section: electronics
Priority: optional
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: ngspice
Description: Quite Universal Circuit Simulator with SPICE (Qucs-S) 
 allows to simulate electronic circuits with SPICE-compatible kernels
